/*
 * Dozen Phi Applet
 * dozen.java -- main class (approach # two; customizability)
 * (C) 1999 Visual Perception Lab, Purdue University
 * Author: Filip Pizlo
 */

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.net.*;

public class dozen extends Applet implements AdjustmentListener,ActionListener {
 public void logit(String msg) {
  System.out.println(getClass().getName()+": "+msg);
 }
 public dozencanvas canv;
 Scrollbar n,b,t,s,r;
 Hashtable labels=new Hashtable();
 Panel controls;
 advcolor cpick;
 public Scrollbar addscroll(String text,int value,int min,int max) {
  Scrollbar ret=new Scrollbar(Scrollbar.HORIZONTAL,value,1,min,max);
  ret.addAdjustmentListener(this);
  Panel p=new Panel(new BorderLayout());
  Panel p2=new Panel(new BorderLayout());
  p2.add("Center",new Label(text));
  Label l=new Label("    ");
  labels.put(ret,l);
  setlabel(ret);
  p2.add("East",l);
  p.add("North",p2);
  p.add("Center",ret);
  controls.add(p);
  return ret;
 }
 public void setlabel(Scrollbar id,String text) {
  Label l=(Label)labels.get(id);
  String buf="";
  int n=4-text.length();
  for (int i=0;i<n;i++) buf+=" ";
  buf+=text;
  l.setText(buf);
 }
 public void setparams(int ndots,int delayt,int dotsize,int radius) {
  n.setValue(ndots);
  b.setValue(delayt/ndots);
  t.setValue(delayt);
  s.setValue(dotsize);
  r.setValue(radius);
  setlabel(n);
  setlabel(b);
  setlabel(t);
  setlabel(s);
  setlabel(r);
  canv.setparams(n.getValue(),s.getValue(),r.getValue(),b.getValue());
 }
 public void setcolors(boolean cmode) {
  canv.setcolors(cmode);
 }
 public void setmulti(boolean multi) {
  canv.setmulti(multi);
 }
 public void setlabel(Scrollbar id) {
  setlabel(id,""+id.getValue());
 }
 boolean running=true;
 Button start;
 public void init() {
  try {
   logit("Starting...");
   setForeground(Color.white);
   setBackground(Color.black);
   canv=new dozencanvas(this);
   canv.setparams(9,5,25,33);
   setLayout(new BorderLayout());
   setFont(new Font("Curier",Font.BOLD,15));
   add("Center",canv);
   Panel southpan=new Panel(new GridLayout(2,1));
   controls=new Panel();
   n=addscroll("# of disks",canv.getdots(),2,18);
   b=addscroll("delay (d)   ",(int)canv.getdelay(),10,1000);
   t=addscroll("delay (t)    ",(int)(canv.getdelay()*canv.getdots()),50,3000);
   southpan.add(controls);
   controls=new Panel();
   s=addscroll("disk size",canv.getsize(),1,20);
   r=addscroll("radius  ",canv.getradius(),3,100);
   southpan.add(controls);
   add("South",southpan);
   start=new Button(" Stop ");
   Button colors=new Button("Toggle Contrast");
   Button multi=new Button("Toggle Double");
   Button arbclrs=new Button("Colors");
   Button def=new Button("Default Magni-phi");
//   Button simpli=new Button("Default Simpli-phi");
   Button expl=new Button("Explanation");
   start.addActionListener(this);
   colors.addActionListener(this);
   multi.addActionListener(this);
   arbclrs.addActionListener(this);
   def.addActionListener(this);
//   simpli.addActionListener(this);
   expl.addActionListener(this);
   Panel ncontrols=new Panel();
   ncontrols.setFont(new Font("Dialog",0,11));
//   ncontrols.add(new Label("Magniphi Applet by Filip Pizlo"));
   ncontrols.add(start);
   ncontrols.add(colors);
   ncontrols.add(arbclrs);
   ncontrols.add(multi);
   ncontrols.add(def);
//   ncontrols.add(simpli);
   ncontrols.add(expl);
   add("North",ncontrols);
   cpick=new advcolor(this);
   setparams(9,294,13,77);
  } catch (Throwable e) {
   logit("Error in init: "+e);
  }
 }
 public void adjustmentValueChanged(AdjustmentEvent evt) {
  Object targ=evt.getAdjustable();
  if (targ==n) {
   b.setValue(t.getValue()/n.getValue());
   setlabel(n);
   setlabel(b);
  } else if (targ==b) {
   t.setValue(b.getValue()*n.getValue());
   setlabel(b);
   setlabel(t);
  } else if (targ==t) {
   b.setValue(t.getValue()/n.getValue());
   setlabel(t);
   setlabel(b);
  } else if (targ==s) {
   // blah
   setlabel(s);
  } else if (targ==r) {
   // blah
   setlabel(r);
  } else return;
  canv.setparams(n.getValue(),s.getValue(),r.getValue(),b.getValue());
 }
 public void actionPerformed(ActionEvent evt) {
  String cmd=evt.getActionCommand();
  if (cmd.equalsIgnoreCase("start")) {
   dostart();
   start.setLabel("Stop");
  } else if (cmd.trim().equalsIgnoreCase("stop")) {
   dostop();
   start.setLabel("Start");
  } else if (cmd.equalsIgnoreCase("toggle contrast")) {
   canv.togglecolors();
  } else if (cmd.equalsIgnoreCase("toggle double")) {
   canv.togglemulti();
  } else if (cmd.equalsIgnoreCase("colors")) {
   cpick.show();
  } else if (cmd.equalsIgnoreCase("toggle beta")) {
   canv.togglebeta();
  } else if (cmd.equalsIgnoreCase("default simpli-phi")) {
   try {
    logit("Attempting to go to simpliphi.target");
    AppletContext ctx=getAppletContext();
    ctx.showDocument(
     new URL(getDocumentBase(),getParameter("simpliphi.target")));
   } catch (Throwable e) {
    logit("Error going to simpliphi.target: "+e);
    setparams(2,290,5,10);
   }
  } else if (cmd.equalsIgnoreCase("explanation")) {
   try {
    logit("Attempting to go to explanation.target");
    AppletContext ctx=getAppletContext();
    ctx.showDocument(
     new URL(getDocumentBase(),getParameter("explanation.target")));
   } catch (Throwable e) {
    logit("Error going to explanation.target: "+e);
   }
  } else if (cmd.equalsIgnoreCase("default magni-phi")) {
   setparams(9,294,13,77);
  }
 }
 public void start() {
  if (running) {
   logit("Starting");
   canv.start();
  }
 }
 public void stop() {
  if (running) {
   canv.stop();
   logit("Stopped");
  }
 }
 public void dostart() {
  running=true;
  start();
 }
 public void dostop() {
  stop();
  running=false;
 }
}





