/*
 * Dozen Phi Applet
 * dozen.java -- main class (approach # two; customizability)
 * (C) 1999 Visual Perception Lab, Purdue University
 * Author: Filip Pizlo
 */

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.net.*;

public class dozen extends Applet implements ActionListener {
 public void logit(String msg) {
  System.out.println(getClass().getName()+": "+msg);
 }
 public dozencanvas canv;
 public void setparams(int ndots,int delayt,int dotsize,int radius,
  boolean multi) {
  canv.setparams(ndots,dotsize,radius,delayt/ndots);
  canv.setmulti(multi);
 }
 public void setcolors(Color bg,Color fg) {
  canv.setBgImage(null,null);
  canv.setcolors(fg,bg);
 }
 public void splitcolors() {
  canv.setBgImage(null,null);
  canv.setcolors(Color.white,Color.black);
  canv.splitColors(Color.red,Color.blue);
 }
 public void settype(int type) {
  canv.setDrawMode(type);
 }
 public void settext(String text,Font font) {
  canv.setText(text,font);
  canv.setDrawMode(dozencanvas.DRAW_TEXT);
 }
 public void setimage() {
  canv.setImage(getImage(getCodeBase(),"meshot.jpg"),new Dimension(44,57));
  canv.setDrawMode(dozencanvas.DRAW_IMAGE);
  setparams(9,294,24,125,true);
  //setparams(9,294,13,130,true);
 }
 public void setbgimage() {
  canv.setBgImage(getImage(getCodeBase(),"cammo.gif"),new Dimension(64,64));
  //setcolors(Color.black,Color.white);
 }
 boolean running=true;
 public void init() {
  try {
   logit("Starting...");
   setForeground(Color.white);
   setBackground(Color.black);
   canv=new dozencanvas(this);
   canv.setparams(9,5,25,33);
   setLayout(new BorderLayout());
   setFont(new Font("Curier",Font.BOLD,15));
   add("Center",canv);
   Panel styles=new Panel(new GridLayout(1,0));
   Panel bgcolor=new Panel(new GridLayout(1,0));
   Panel types=new Panel(new GridLayout(1,0));
   Panel texts=new Panel(new GridLayout(1,0));
   Panel top=new Panel(new BorderLayout());
   Panel left=new Panel(new GridLayout(4,1));
   left.add(new Label("Styles:"));
   left.add(new Label("Backgrounds:"));
   left.add(new Label("Symbols:"));
   left.add(new Label("Other:"));
   top.add("West",left);
   Panel right=new Panel(new GridLayout(4,1));
   right.add(styles);
   right.add(bgcolor);
   right.add(types);
   right.add(texts);
   top.add("Center",right);
   Button beta=new Button("Beta");	beta.addActionListener(this);
   Button phi=new Button("Phi");	phi.addActionListener(this);
   Button four=new Button("Four");	four.addActionListener(this);
   Button magni=new Button("Magni");	magni.addActionListener(this);
   Button slow9=new Button("Slow-9");	slow9.addActionListener(this);
   styles.add(beta);
   styles.add(phi);
   styles.add(four);
   styles.add(magni);
   styles.add(slow9);
   Button black=new Button("Black");	black.addActionListener(this);
   Button white=new Button("White");	white.addActionListener(this);
   Button red=new Button("Red");	red.addActionListener(this);
   Button green=new Button("Green");	green.addActionListener(this);
   Button blue=new Button("Blue");	blue.addActionListener(this);
   bgcolor.add(black);
   bgcolor.add(white);
   bgcolor.add(red);
   bgcolor.add(green);
   bgcolor.add(blue);
   Button disk=new Button("Disk");	disk.addActionListener(this);
   Button circle=new Button("Circle");	circle.addActionListener(this);
   Button box=new Button("Box");	box.addActionListener(this);
   Button square=new Button("Square");	square.addActionListener(this);
   Button poly=new Button("Polygon");	poly.addActionListener(this);
   types.add(disk);
   types.add(circle);
   types.add(box);
   types.add(square);
   types.add(poly);
   Button eych=new Button("\"H\"");	eych.addActionListener(this);
   Button PHI=new Button("\"PHI\"");	PHI.addActionListener(this);
   Button split=new Button("Split");	split.addActionListener(this);
   Button me=new Button("Filip");	me.addActionListener(this);
   me.setFont(new Font("Serif",2,15));
   texts.add(eych);
   texts.add(PHI);
   texts.add(split);
   texts.add(me);
   add("North",top);
   //setparams(2,950,24,70,false);
   setparams(2,950,16,41,false);
   //setparams(2,205,14,28,false);
  } catch (Throwable e) {
   logit("Error in init: "+e);
  }
 }
 Color darkGreen=new Color(0,150,0);
 boolean filipSet=false;
 public void actionPerformed(ActionEvent evt) {
  String cmd=evt.getActionCommand();
  if (filipSet) {
   setparams(9,294,13,77,true);
   settype(dozencanvas.FILL_OVAL);
   filipSet=false;
  }
  if (cmd.equals("Beta"))		setparams(2,950,16,41,false);
  else if (cmd.equals("Phi"))		setparams(2,205,14,28,false);
  else if (cmd.equals("Magni"))		setparams(9,294,13,77,true);
  else if (cmd.equals("Four"))		setparams(4,294,13,44,true);
  else if (cmd.equals("Slow-9"))	setparams(9,3500,13,77,false);
  else if (cmd.equals("Black"))		setcolors(Color.black,Color.white);
  else if (cmd.equals("White"))		setcolors(Color.white,Color.black);
  else if (cmd.equals("Red"))		setcolors(Color.red,Color.white);
  else if (cmd.equals("Green"))		setcolors(darkGreen,Color.white);
  else if (cmd.equals("Blue"))		setcolors(Color.blue,Color.white);
  else if (cmd.equals("Disk"))		settype(dozencanvas.FILL_OVAL);
  else if (cmd.equals("Circle"))	settype(dozencanvas.DRAW_OVAL);
  else if (cmd.equals("Box"))		settype(dozencanvas.FILL_RECT);
  else if (cmd.equals("Square"))	settype(dozencanvas.DRAW_RECT);
  else if (cmd.equals("Polygon"))	settype(dozencanvas.FILL_POLY);
  else if (cmd.equals("\"PHI\""))	settext("PHI",new Font("Dialog",0,15));
  else if (cmd.equals("\"H\""))		settext("H",new Font("Dialog",0,25));
  else if (cmd.equals("Split"))		splitcolors();
  else if (cmd.equals("Filip")) {
   setimage();
   filipSet=true;
  }
 }
 public void start() {
  if (running) {
   logit("Starting");
   canv.start();
  }
 }
 public void stop() {
  if (running) {
   canv.stop();
   logit("Stopped");
  }
 }
 public void dostart() {
  running=true;
  start();
 }
 public void dostop() {
  stop();
  running=false;
 }
}





