/*
 * Rotating Logo Graphlet
 * rotlogo.java -- main applet class
 * (C) 1998-2000 Filip Pizlo
 *
 * Based on the Rotating Logo Applet
 */

import java.applet.*;
import java.awt.*;
import java.net.*;
import java.util.*;

public class rotlogo extends graphlet implements Runnable {
 Image img;
 Image buf;
 Thread th;
 int crp;
 Color ciq;
 boolean xor,uth;
 Font f;
 public void init() {
  try {
   img=getImage(getCodeBase(),getParameter("img"));
   crp=Integer.parseInt(getParameter("crp"));
   ciq=Color.decode(getParameter("ciq"));
   xor=getParameter("xor").equalsIgnoreCase("true");
   uth=getParameter("uth").equalsIgnoreCase("true");
  } catch (Throwable e) {
   System.err.println("Error in init: "+e);
  }
 }
 public void start() {
  done=false;
  th=new Thread(this);
  th.start();
 }
 public void stop() {
  done=false;
  try {
   th.stop();
   th=null;
  } catch (Throwable e) {
   System.err.println("Error in stop: "+e);
  }
 }
 boolean done=false;
 Random rand=new Random();
 double offX,offY,offZ,minX,minY,minZ,maxX,maxY,maxZ,dX,dY,dZ,
  offDivX,offDivY,offDivZ,rotD,rotMin,rotMax,rotDiv;
 public void paint(Graphics g) {
  try {
   if (!done) return;
   double lastOffX=offX,lastOffY=offY,lastOffZ=offZ;
   offX+=dX;
   offY+=dY;
   offZ+=dZ;
   //dX=rand.nextDouble()*((maxX-minX)/offDiv);
   //dY=rand.nextDouble()*((maxY-minY)/offDiv);
   if (offX>=maxX) {
    System.out.println("offX>=maxX: offX="+offX+" maxX="+maxX+" dX="+dX);
    dX=-Math.abs(dX);
    offX+=dX;
    dY=rand.nextDouble()*((maxY-minY)/offDivY)*((double)(rand.nextInt()%2));
    dZ=rand.nextDouble()*((maxZ-minZ)/offDivZ)*((double)(rand.nextInt()%2));
    rotD=(rand.nextDouble()*(rotMax-rotMin))+rotMin;
   }
   if (offX<=minX) {
    System.out.println("offX<=minX: offX="+offX+" minX="+minX+" dX="+dX);
    dX=Math.abs(dX);
    offX+=dX;
    dY=rand.nextDouble()*((maxY-minY)/offDivY)*((double)(rand.nextInt()%2));
    dZ=rand.nextDouble()*((maxZ-minZ)/offDivZ)*((double)(rand.nextInt()%2));
    rotD=(rand.nextDouble()*(rotMax-rotMin))+rotMin;
   }
   if (offY>=maxY) {
    System.out.println("offY>=maxY: offY="+offY+" maxY="+maxY+" dY="+dY);
    dY=-Math.abs(dY);
    offY+=dY;
    dX=rand.nextDouble()*((maxX-minX)/offDivX)*((double)(rand.nextInt()%2));
    dZ=rand.nextDouble()*((maxZ-minZ)/offDivZ)*((double)(rand.nextInt()%2));
    rotD=(rand.nextDouble()*(rotMax-rotMin))+rotMin;
   }
   if (offY<=minY) {
    System.out.println("offY<=minY: offY="+offY+" minY="+minY+" dY="+dY);
    dY=Math.abs(dY);
    offY+=dY;
    dX=rand.nextDouble()*((maxX-minX)/offDivX)*((double)(rand.nextInt()%2));
    dZ=rand.nextDouble()*((maxZ-minZ)/offDivZ)*((double)(rand.nextInt()%2));
    rotD=(rand.nextDouble()*(rotMax-rotMin))+rotMin;
   }
   if (offZ>=maxZ) {
    System.out.println("offZ>=maxZ: offZ="+offZ+" maxZ="+maxZ+" dZ="+dZ);
    dZ=-Math.abs(dZ);
    offZ+=dZ;
    dX=rand.nextDouble()*((maxX-minX)/offDivX)*((double)(rand.nextInt()%2));
    dY=rand.nextDouble()*((maxY-minY)/offDivY)*((double)(rand.nextInt()%2));
    rotD=(rand.nextDouble()*(rotMax-rotMin))+rotMin;
   }
   if (offZ<=minZ) {
    System.out.println("offZ<=minZ: offZ="+offZ+" minZ="+minZ+" dZ="+dZ);
    dZ=Math.abs(dZ);
    offZ+=dZ;
    dX=rand.nextDouble()*((maxX-minX)/offDivX)*((double)(rand.nextInt()%2));
    dY=rand.nextDouble()*((maxY-minY)/offDivY)*((double)(rand.nextInt()%2));
    rotD=(rand.nextDouble()*(rotMax-rotMin))+rotMin;
   }
   double cdeg=Math.cos(rotD);
   double sdeg=Math.sin(rotD);
   for (int k=1;k<vect.size();k++) {
    poly3d poly=(poly3d)vect.elementAt(k);
    for (int j=0;j<poly.npoints;j++) {
     double x=((Double)poly.x.elementAt(j)).doubleValue();
     double y=((Double)poly.y.elementAt(j)).doubleValue();
     double z=((Double)poly.z.elementAt(j)).doubleValue();
     // translate
     x-=lastOffX;
     y-=lastOffY;
     z-=lastOffZ;
     // rotate
     double x1=x*cdeg-z*sdeg;
     double y1=y;
     double z1=x*sdeg+z*cdeg;
     // translate
     x1+=offX;
     y1+=offY;
     z1+=offZ;
     // save
     poly.x.setElementAt(new Double(x1),j);
     poly.y.setElementAt(new Double(y1),j);
     poly.z.setElementAt(new Double(z1),j);
    }
    poly.refresh();
    vect.setElementAt(poly,k);
   }
   //g.setPaintMode();
   //g.setColor(Color.white);
   //g.fillRect(0,0,size().width,size().height);
   if (xor) g.setXORMode(ciq);
   else g.setColor(ciq);
   for (int i=1;i<vect.size();i++) {
    Polygon poly=(Polygon)vect.elementAt(i);
    //g.translate((int)offX,(int)offY);
    g.fillPolygon(poly);
    //g.translate(-((int)offX),-((int)offY));
   }
   g.setPaintMode();
  } catch (Throwable e) {
   System.err.println("Error in ROTLOGO paint:");
   e.printStackTrace(System.err);
  }
 }
 Vector vect;
 public void run() {
  try {
   System.out.println("IN THREAD");
   offX=Integer.parseInt(getParameter("offset.start.x"));
   offY=Integer.parseInt(getParameter("offset.start.y"));
   offZ=Integer.parseInt(getParameter("offset.start.z"));
   minX=Integer.parseInt(getParameter("offset.min.x"));
   minY=Integer.parseInt(getParameter("offset.min.y"));
   minZ=Integer.parseInt(getParameter("offset.min.z"));
   maxX=Integer.parseInt(getParameter("offset.max.x"));
   maxY=Integer.parseInt(getParameter("offset.max.y"));
   maxZ=Integer.parseInt(getParameter("offset.max.z"));
   offDivX=Integer.parseInt(getParameter("offset.divisor.x"));
   offDivY=Integer.parseInt(getParameter("offset.divisor.y"));
   offDivZ=Integer.parseInt(getParameter("offset.divisor.z"));
   dX=rand.nextDouble()*((maxX-minX)/offDivX);
   dY=rand.nextDouble()*((maxY-minY)/offDivY);
   dZ=rand.nextDouble()*((maxZ-minZ)/offDivZ);
   rotD=Double.valueOf(getParameter("rotate.angle")).doubleValue();
   rotMin=Double.valueOf(getParameter("rotate.min")).doubleValue();
   rotMax=Double.valueOf(getParameter("rotate.max")).doubleValue();
   vect=polygonizer.img2poly(img,size(),crp);
   done=true;
   if (!uth) return;
   while (true) {
    repaint();
    Thread.sleep(100);
   }
  } catch (Throwable e) {
   System.err.println("Error in ROTLOGO thread:");
   e.printStackTrace(System.err);
  }
 }
}


